#ifndef INTERFACE_H
#define INTERFACE_H

#include <string>
#include "FC_namemangling.h"

void hepmc3eventinit(const char *filename, int lfilename);
void hepmc3eventwrite();
void hepmc3eventclose();

void hepmc3eventaddparticlein(int barcode, double px, double py, double pz, double e, int status);
void hepmc3eventaddparticleout(int barcode, double px, double py, double pz, double e, int status);

void hepmc3eventinitevent(double weight);

void hepmc3eventattributeimpact(double value);
void hepmc3eventattributeeventtype(int value);

void hepmc3eventsetposition(double x, double y, double z);

std::string strFtoC(const char *str, int len);

// Wrappers from FORTRAN subroutines to C++ functions

#ifdef __cplusplus
extern "C" {
#endif
  void FortranCInterface_GLOBAL(hepmc3eventinit,HEPMC3EVENTINIT)(const char *filename, int lfilename)
  {hepmc3eventinit(filename, lfilename);};
  void FortranCInterface_GLOBAL(hepmc3eventwrite,HEPMC3EVENTWRITE)()
  {hepmc3eventwrite();};
  void FortranCInterface_GLOBAL(hepmc3eventclose,HEPMC3EVENTCLOSE)()
  {hepmc3eventclose();};

  void FortranCInterface_GLOBAL(hepmc3eventaddparticlein,HEPMC3EVENTADDPARTICLEIN)(int *barcode, double *px, double *py, double *pz, double *e, int *status)
  {hepmc3eventaddparticlein(*barcode, *px, *py, *pz, *e, *status);};
  void FortranCInterface_GLOBAL(hepmc3eventaddparticleout,HEPMC3EVENTADDPARTICLEOUT)(int *barcode, double *px, double *py, double *pz, double *e, int *status)
  {hepmc3eventaddparticleout(*barcode, *px, *py, *pz, *e, *status);};

  void FortranCInterface_GLOBAL(hepmc3eventinitevent,HEPMC3EVENTINITEVENT)(double *weight)
  {hepmc3eventinitevent(*weight);};

  void FortranCInterface_GLOBAL(hepmc3eventattributeimpact,HEPMC3EVENTATTRIBUTEIMPACT)(double *value)
  {hepmc3eventattributeimpact(*value);};
  void FortranCInterface_GLOBAL(hepmc3eventattributeeventtype,HEPMC3EVENTATTRIBUTEEVENTTYPE)(int *value)
  {hepmc3eventattributeeventtype(*value);};

  void FortranCInterface_GLOBAL(hepmc3eventsetposition,HEPMC3EVENTSETPOSITION)(double *x, double *y, double *z)
  {hepmc3eventsetposition(*x,*y,*z);};
#ifdef __cplusplus
}
#endif



#endif // INTERFACE_H
